/**
*U-Anywhere App
* Implementing UAnywhere App
*/
var UDynamicDnsApp = UDynamicDnsApp || {};  //Define UAnywhere App namespace.
/**
*Constructor UNAS App
*/
UDynamicDnsApp.App = function () {
    this.id = 'Dynamic DNS';
    this.name = 'Dynamic DNS';
    this.version = '0.0.24';
    this.active = false;
    this.menuIcon = '/apps/dynamicdns/images/logo.png?v=SOLVE_BROWSER_CACHE&';
    this.shortcutIcon = '/apps/dynamicdns/images/logo.png?v=SOLVE_BROWSER_CACHE&';
    this.entryUrl = '/apps/dynamicdns/dist/index.html?v=SOLVE_BROWSER_CACHE&';
    //this.entryHelpUrl = '/apps/dynamicdns/uanywhere_help.html?v=SOLVE_BROWSER_CACHE&';
    var self = this;
    this.UDynamicDnsAppWindow = function () { //create app window
        if (UNAS.CheckAppState('Dynamic DNS')) {
            return false;
        }
        //load app setting
        self.window = new MUI.Window({
            id: 'UDynamicDnsAppWindow',
            title: UNAS._('Dynamic DNS'),
            icon: '/apps/dynamicdns/images/logo_small.png?v=SOLVE_BROWSER_CACHE&',
            loadMethod: 'iframe',
            width: 1120,
            height: 700,
            maximizable: false,
            resizable: false,
            scrollbars: false,
            resizeLimit: { 'x': [1120, 1120], 'y': [700, 700] },
            contentURL: '/apps/dynamicdns/dist/index.html?v=SOLVE_BROWSER_CACHE&',
            require: {
                js: [
                    '/apps/dynamicdns/dist/assets/index-e142c3f3.js',
                ],
                css: [
                    '/apps/dynamicdns/dist/assets/index-f3df6ac0.css',
                ],
                // require含有js时没有onload函数将报错，因此写一个空的onload函数
                onload: function () {
                }
            },
            onBeforeBuild: function () { UNAS.SetAppOpenedWindow("U-Anywhere", 'UDynamicDnsAppWindow') }
        });
    };
    this.UAnywhereUninstall = function () {
        UNAS.RemoveDesktopShortcut('Dynamic DNS');
        UNAS.RemoveMenu('Dynamic DNS');
        UNAS.RemoveAppFromGroups('Dynamic DNS', 'ControlPanel');
        //UNAS.RemoveAppFromGroups('Dynamic DNS', 'Help');
        UNAS.RemoveAppFromApps('Dynamic DNS');
    };
    new UNAS.Menu('UNAS_App_SystemTools_Menu', this.name, this.menuIcon, 'Dynamic DNS', '', this.UDynamicDnsAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Dynamic DNS', this.UDynamicDnsAppWindow);

    // new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', { "Type": "Network", "Location": 4, "Icon": this.shortcutIcon, "Url": this.entryUrl }, {});

    //new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {"Type" : "Network", "Location" : 0, "Icon": this.shortcutIcon, "Url": this.entryUrl}, {});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Internet', 'Laction' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Dynamic DNS', UNAS._('Dynamic DNS')); //translate menu
        UNAS.SetShortcutTitle('Dynamic DNS', UNAS._('Dynamic DNS'));
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('UDynamicDnsAppWindow', UNAS._('Dynamic DNS'));
        }


        var iframe = document.getElementById('UDynamicDnsAppWindow_iframe');
        if (iframe) {
            var data = { currentLanguage: window.top.UNAS.CurrentLanguage };
            iframe.contentWindow.postMessage(data, '*');
        }


    };
    UNAS.LoadTranslation('/apps/dynamicdns/languages/Translation?v=' + this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.UDynamicDnsAppWindow, this.UAnywhereUninstall);
};

new UDynamicDnsApp.App();
